(function ($, Drupal, drupalSettings) {

  "use strict";

  Drupal.behaviors.klaroEditor = {
    attach: function (context) {
      var initEditor = function () {
        $('textarea[data-klaro-editor]', context).once('klaro-editor').each(function () {
          var $textarea = $(this);
          var $editDiv = $('<div>').insertBefore($textarea);
          $editDiv.css({ fontSize: 18 });

          $textarea.addClass('visually-hidden');

          // Init ace editor.
          ace.config.set('basePath', 'https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.11/');
          var editor = ace.edit($editDiv[0]);
          editor.session.setValue($textarea.val());
          editor.session.setMode("ace/mode/json");
          editor.session.setTabSize(2);
          editor.setTheme('ace/theme/chrome');
          editor.setOptions({
            minLines: 3,
            maxLines: 20
          });

          // Update Drupal textarea value.
          editor.getSession().on('change', function () {
            $textarea.val(editor.getSession().getValue());
          });
        });
      };

      // Initialize editor.
      if (typeof ace !== 'undefined') {
        initEditor();
      }
    }
  };

})(jQuery, Drupal, drupalSettings);
