(function (Drupal, drupalSettings) {

  'use strict';

  Drupal.behaviors.klaro = {
    attach: function attach(context) {
      if (drupalSettings.klaroConfig !== undefined && context === document) {
        // Open preferences
        let preferences = document.querySelectorAll("#klaro-preferences, .klaro-preferences");
        if (drupalSettings.klaroConfig.services !== undefined) {
          drupalSettings.klaroConfig.services.forEach(function(value, index) {
            if (drupalSettings.klaroConfig.services[index].callback !== undefined) {
              drupalSettings.klaroConfig.services[index].callback = new Function(`return ${drupalSettings.klaroConfig.services[index].callback}`)();
            }
          });
        }

        if (preferences !== null) {
          preferences.forEach(function(button) {
            button.addEventListener("click", function (e) {
              e.preventDefault();
              klaro.show(drupalSettings.klaroConfig);
            });
          })
        }
        // Render klaro
        klaro.render(drupalSettings.klaroConfig);
      }
    },
  };
})(Drupal, drupalSettings);
